<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="用户ID" prop="userId">
        <el-input v-model="formData.userId" placeholder="请输入用户ID" />
      </el-form-item>
      <el-form-item label="评价人名称" prop="userNickname">
        <el-input v-model="formData.userNickname" placeholder="请输入评价人名称" />
      </el-form-item>
      <el-form-item label="评价人头像" prop="userAvatar">
        <el-input v-model="formData.userAvatar" placeholder="请输入评价人头像" />
      </el-form-item>
      <el-form-item label="是否匿名" prop="anonymous">
        <el-radio-group v-model="formData.anonymous">
          <el-radio
            v-for="dict in getBoolDictOptions(DICT_TYPE.$dictType.toUpperCase())"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="任务ID" prop="taskRecordId">
        <el-input v-model="formData.taskRecordId" placeholder="请输入任务ID" />
      </el-form-item>
      <el-form-item label="商品ID" prop="productId">
        <el-input v-model="formData.productId" placeholder="请输入商品ID" />
      </el-form-item>
      <el-form-item label="商品名称" prop="productName">
        <el-input v-model="formData.productName" placeholder="请输入商品名称" />
      </el-form-item>
      <el-form-item label="是否可见" prop="visible">
        <el-radio-group v-model="formData.visible">
          <el-radio
            v-for="dict in getBoolDictOptions(DICT_TYPE.$dictType.toUpperCase())"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="评分星级" prop="scores">
        <el-input v-model="formData.scores" placeholder="请输入评分星级" />
      </el-form-item>
      <el-form-item label="评论内容">
        <Editor v-model="formData.content" height="150px" />
      </el-form-item>
      <el-form-item label="评论图片地址数组" prop="picUrls">
        <el-input v-model="formData.picUrls" placeholder="请输入评论图片地址数组" />
      </el-form-item>
      <el-form-item label="商家是否回复" prop="replyStatus">
        <el-radio-group v-model="formData.replyStatus">
          <el-radio
            v-for="dict in getBoolDictOptions(DICT_TYPE.$dictType.toUpperCase())"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="回复管理员编号，关联 AdminUserDO 的 id 编号" prop="replyUserId">
        <el-input v-model="formData.replyUserId" placeholder="请输入回复管理员编号，关联 AdminUserDO 的 id 编号" />
      </el-form-item>
      <el-form-item label="商家回复内容">
        <Editor v-model="formData.replyContent" height="150px" />
      </el-form-item>
      <el-form-item label="商家回复时间" prop="replyTime">
        <el-date-picker
          v-model="formData.replyTime"
          type="date"
          value-format="x"
          placeholder="选择商家回复时间"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { DICT_TYPE, getBoolDictOptions } from '@/utils/dict'
import * as TaskCommentApi from '@/api/member/taskComment'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  userId: undefined,
  userNickname: undefined,
  userAvatar: undefined,
  anonymous: undefined,
  taskRecordId: undefined,
  productId: undefined,
  productName: undefined,
  visible: undefined,
  scores: undefined,
  content: undefined,
  picUrls: undefined,
  replyStatus: undefined,
  replyUserId: undefined,
  replyContent: undefined,
  replyTime: undefined
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await TaskCommentApi.getTaskComment(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as TaskCommentApi.TaskCommentVO
    if (formType.value === 'create') {
      await TaskCommentApi.createTaskComment(data)
      message.success(t('common.createSuccess'))
    } else {
      await TaskCommentApi.updateTaskComment(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    userId: undefined,
    userNickname: undefined,
    userAvatar: undefined,
    anonymous: undefined,
    taskRecordId: undefined,
    productId: undefined,
    productName: undefined,
    visible: undefined,
    scores: undefined,
    content: undefined,
    picUrls: undefined,
    replyStatus: undefined,
    replyUserId: undefined,
    replyContent: undefined,
    replyTime: undefined
  }
  formRef.value?.resetFields()
}
</script>
